package me.totalfreedom.totalfreedommod.command.impl;

import java.util.List;
import me.totalfreedom.totalfreedommod.command.FreedomCommand;
import me.totalfreedom.totalfreedommod.command.input.CommandParameters;
import me.totalfreedom.totalfreedommod.command.input.CommandPermissions;
import me.totalfreedom.totalfreedommod.command.input.SourceType;
import me.totalfreedom.totalfreedommod.config.ConfigEntry;
import me.totalfreedom.totalfreedommod.rank.Rank;
import me.totalfreedom.totalfreedommod.util.FUtil;
import org.apache.commons.lang.StringUtils;
import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

@CommandPermissions(level = Rank.OP, source = SourceType.BOTH)
@CommandParameters(name = "vote", description = "Information on how to vote", usage = "/<command>")
public class VoteCMD extends FreedomCommand {

    @Override
    public boolean run(CommandSender sender, Player playerSender, Command cmd, String commandLabel, String[] args, boolean senderIsConsole) {
        List<String> voteInfo = ConfigEntry.VOTING_INFO.getStringList();

        if (voteInfo.isEmpty()) {
            msg("The voting information section of the config.yml file has not been configured.", ChatColor.RED);
        } else {
            msg(FUtil.colorize(StringUtils.join(voteInfo, "\n")));
        }

        return true;
    }
}
