package me.totalfreedom.totalfreedommod.world;

import me.totalfreedom.totalfreedommod.services.AbstractService;
import me.totalfreedom.totalfreedommod.util.FLog;
import org.bukkit.Bukkit;
import org.bukkit.World;
import org.bukkit.entity.Player;

public abstract class AbstractWorld extends AbstractService
{
    private final String name;
    //
    private World world;

    public AbstractWorld(String name)
    {
        this.name = name;
    }

    @Override
    public void onStart()
    {
    }

    @Override
    public void onStop()
    {
    }

    public final World getWorld()
    {
        if (world == null || !Bukkit.getWorlds().contains(world))
        {
            world = generateWorld();
        }

        if (world == null)
        {
            FLog.warning("Could not load world: " + name);
        }

        return world;
    }

    public void sendToWorld(Player player)
    {
        try
        {
            player.teleportAsync(getWorld().getSpawnLocation());
        }
        catch (Exception ex)
        {
            player.sendMessage(ex.getMessage());
        }
    }

    protected abstract World generateWorld();

    public String getName()
    {
        return name;
    }
}
